#include <avr/io.h>           			// Zugriff auf IO's des Controllers
#include <avr/interrupt.h>				// Zugriff auf Interrupts
#include <util/delay.h>					// Funktionalitt fr Verzgerungen einbinden
#include <inttypes.h>					// Datentyp Integer einbinden
#include <stdbool.h>					// Datentyp BOOL einbinden
#include "can.h"						// CAN Bibliotehk


volatile char todo = 0;

CAN_message msg0;
CAN_message msg1;




int main(void){
 
  
  CAN_init(125,RX);

/////////////////////////////////////  

  msg0.id = 0x00000003;
  msg0.idm = 0xffffffff;

  msg0.data[0] = 0x11;
  msg0.data[0] = 0x11;
  msg0.data[1] = 0x22;
  msg0.data[2] = 0x33;
  msg0.data[3] = 0x44;
  msg0.data[4] = 0x55;
  msg0.data[5] = 0x66;
  msg0.data[6] = 0x77;
  msg0.data[7] = 0x88;	
  

  CAN_enableMOB(0, RECEIVE_DATA,msg0);

///////////////////////////////////////

  msg1.id = 0x00000001;
  msg1.idm = 0xffffffff;
	

  CAN_enableMOB(1, RECEIVE_DATA, msg1);


	
  sei();		
	
  while(1){
 	if (todo == 1){
		todo = 0;
		CAN_sendData(0 , msg0.data);

		
  	}
  }
}

//////////////////////////////////////////////////////////////////////////////////
//																				//
// Funktion:		SIGNAL()													//
// 																				//
// Beschreibung: 	Interrupt fr den Empfang einer Nachricht.					//
//																				//
//////////////////////////////////////////////////////////////////////////////////
SIGNAL(SIG_CAN_INTERRUPT1){
	uint8_t		save_canpage;
 	static		CAN_message message;

	// Aktuelle CANPAGE sichern
 	save_canpage	= CANPAGE;

    // Index des MOB ermitteln, der den Interrupt ausgelst hat
	uint8_t mob 	= CAN_getMOBInterrupt();
    
	// Falls es kein gltiges MOB war abbrechen
	if(mob == NOMOB){
		return;
	}

	// Objekt das den Interrupt ausgelst hat holen
	CAN_getMOB(mob);
    
	// Daten des MOBs aus CANMSG auslesen
	message			= CAN_getData();
	
	// Id der Nachricht holen
	message.id		= CAN_getID();

	/*------------------------------
	- Daten verarbeiten / ausgeben -
	------------------------------*/
	

	if ((message.id == 0x00000001)&&(todo == 0)){
		 todo = 1;
	}


	// RXOK-Flag lschen
	clearbit(CANSTMOB, RXOK);
    
	// MOB auf Empfang und CAN 2.0B Standard setzen
	CAN_setMode(RECEIVE_DATA);
    
    // CANPAGE wiederherstellen
	CANPAGE		= save_canpage;
}
